//---------------------------------------------------------------------------
#ifndef IvoryDrawH
#define IvoryDrawH

#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <ddraw.h>

#if __BORLANDC__==0x520
#define __IvoryBCB1__
#define IVORY_package
#define IVORY_dcr
#else
#define __IvoryBCB3__
#define IVORY_smartinit
#define IVORY_package PACKAGE
#define IVORY_dcr USERES("ivory.dcr");
#endif

#include "IvoryError.h"
#include "IvoryBitmap.h"
#include "IvoryMapper.h"
#include "IvoryCanvas.h"
#include "IvoryPalette.h"
#include "IvorySurface.h"
//---------------------------------------------------------------------------

class TIvorySurface;
class TIvoryPalette;

class IVORY_package TIvoryDraw : public TComponent
{
   friend TIvorySurface;
   friend TIvoryPalette;
private:
   HWND FHandle;
   bool FExclusiveMode;
   bool FAutoActivate;
   LPDIRECTDRAW FDirectDraw;
   bool FAutoHideCursor;
   TIvorySurface* FPrimarySurface;
   TIvorySurface* FBackSurface;
   TIvorySurface* FTheBackSurface;
   TIvoryPalette* FPalette;

   bool FActive;

   Classes::TNotifyEvent FOriginalFormCreate;

   Classes::TNotifyEvent FOnCreate;
   Classes::TNotifyEvent FOnDestroy;
   Classes::TNotifyEvent FOnActivate;
   Classes::TNotifyEvent FOnDeactivate;
   TExceptionEvent FOnException;
protected:
   void __fastcall SetActive(bool active);
   void __fastcall SetExclusiveMode(bool exclusive);
   void __fastcall SetPalette(TIvoryPalette* palette);
   void __fastcall AfterConstruction();
   void __fastcall BeforeDestruction();
   void __fastcall AddSurface(TIvorySurface* surface);
   void __fastcall ReleaseSurface(TIvorySurface* surface);
   void __fastcall AddPalette(TIvoryPalette* pal);
   void __fastcall ReleasePalette(TIvoryPalette* pal);
   void __fastcall HandleException(TObject* Sender, Exception* E);
   void __fastcall FormPaint(TObject* Sender);
   void __fastcall AutoCreateSurfaces();
   void __fastcall SetBackSurface(TIvorySurface* surface);
   void __fastcall FormCreate(TObject* Sender);
public:
   __fastcall TIvoryDraw(Classes::TComponent* AOwner);
   __fastcall ~TIvoryDraw();
   void __fastcall Flip();

   __property HWND Handle = { read=FHandle };
   __property LPDIRECTDRAW DirectDraw = { read=FDirectDraw };
   __property TIvorySurface* PrimarySurface = { read=FPrimarySurface };
   __property bool Active = { read=FActive, write=SetActive };
__published:
   __property bool AutoActivate = { read=FAutoActivate, write=FAutoActivate, default=true };
   __property bool AutoHideCursor = { read=FAutoHideCursor, write=FAutoHideCursor, default=true };
   __property bool ExclusiveMode = { read=FExclusiveMode, write=SetExclusiveMode, default=false };
   __property TIvoryPalette* Palette = { read=FPalette, write=SetPalette, default=NULL};
   __property TIvorySurface* BackSurface = { read=FBackSurface, write=SetBackSurface, default=NULL };

   __property Classes::TNotifyEvent OnCreate = { read=FOnCreate, write=FOnCreate, default=NULL };
   __property Classes::TNotifyEvent OnDestroy = { read=FOnDestroy, write=FOnDestroy, default=NULL };
   __property Classes::TNotifyEvent OnActivate = { read=FOnActivate, write=FOnActivate, default=NULL };
   __property Classes::TNotifyEvent OnDeactivate = { read=FOnDeactivate, write=FOnDeactivate, default=NULL };
   __property TExceptionEvent OnException = { read=FOnException, write=FOnException, default=NULL };
};

extern TIvoryDraw* TheIvoryDraw;
extern TColor __fastcall ToTColor(int palindex);
//---------------------------------------------------------------------------
#endif

