//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

//#include "IvoryDraw.h"
//---------------------------------------------------------------------------
static inline TIvoryMapper* ValidCtrCheckMapper()
{
	return new TIvoryMapper(NULL);
}
//---------------------------------------------------------------------------
__fastcall TIvoryMapper::TIvoryMapper(Classes::TComponent* AOwner)
 : TComponent(AOwner), FTileWidth(0), FTileHeight(0), FTiles(0)
{
	FSurface = new TIvorySurface(this);
}
//---------------------------------------------------------------------------
__fastcall TIvoryMapper::~TIvoryMapper()
{
//	delete FSurface;
}
//---------------------------------------------------------------------------
// calculate the number of tile rows
int __fastcall TIvoryMapper::GetTileRows() const
{
	if(Bitmap && TileHeight > 0)
		return Bitmap->Height / TileHeight;
   else
   	return 0;
}
//---------------------------------------------------------------------------
// calcualte the number of tile columns
int __fastcall TIvoryMapper::GetTileColumns() const
{
	if(Bitmap && TileWidth > 0)
   	return Bitmap->Width / TileWidth;
   else
   	return 0;
}
//---------------------------------------------------------------------------
// calcualte the tile rectangle
TRect __fastcall TIvoryMapper::GetTileRect(int n) const
{
   int rows = TileRows, cols = TileColumns, maxtiles = min(rows * cols, Tiles);
   if(n < 0) n = 0;
   if(n >= maxtiles) n = maxtiles - 1;
   int x = n % cols * TileWidth, y = n / cols * TileHeight;
   return Rect(x, y, x + TileWidth, y + TileHeight);
}
//---------------------------------------------------------------------------
// create a new surface and set its bitmap
void __fastcall TIvoryMapper::SetBitmap(TIvoryBitmap* bitmap)
{
	if(bitmap && bitmap->Handle && bitmap != Bitmap)
   {
	   Surface->BackgroundBitmap = bitmap;
   	Surface->DrawBackground = true;
      FTileRows = GetTileRows();
      FTileColumns = GetTileColumns();
      if(TheIvoryDraw && TheIvoryDraw->Active)
      {
      	if(Surface->DirectDrawSurface)
			   Surface->RecreateOffScreen(bitmap->Width, bitmap->Height);
         else
         {
         	Surface->Width = bitmap->Width;
         	Surface->Height = bitmap->Height;
			   Surface->CreateOffScreen();
         }
      }
   }
}
//---------------------------------------------------------------------------
// get the bitmap from the surface
TIvoryBitmap* __fastcall TIvoryMapper::GetBitmap() const
{
	return Surface->BackgroundBitmap;
}
//---------------------------------------------------------------------------
// is the surface transparent? You can set it even if the surface's not yet defined
void __fastcall TIvoryMapper::SetTransparent(bool transparent)
{
   if(Surface->DirectDrawSurface)
	   Surface->RecreateOffScreen(Surface->Width, Surface->Height, transparent, Surface->TransparentColor);
   else
		Surface->Transparent = transparent;
}
//---------------------------------------------------------------------------
bool __fastcall TIvoryMapper::GetTransparent() const
{
	return Surface->Transparent;
}
//---------------------------------------------------------------------------
// set the surface transparent color. You can set it even if the surface's not yet defined
void __fastcall TIvoryMapper::SetTransparentColor(int color)
{
   if(Surface->DirectDrawSurface)
	   Surface->RecreateOffScreen(Surface->Width, Surface->Height, Surface->Transparent, color);
   else
		Surface->TransparentColor = color;
}
//---------------------------------------------------------------------------
int __fastcall TIvoryMapper::GetTransparentColor() const
{
	return Surface->TransparentColor;
}
//---------------------------------------------------------------------------

